#include <bits/stdc++.h>
using namespace std;
#define maxa 1e9
int n, q;

int main()
{
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    while(q--){
        int l, r;
        cin >> l >> r;
        l--, r--;
        set<int> s;
        for (int i = l; i < r; i++) {
            for (int j = i + 1; j <= r; j++) {
                if (a[i] & a[j] > a[i] ^ a[j]) {
                    cout << a[i] << " " << a[j] << endl;
                    s.insert(a[i]);
                    s.insert(a[j]);
                }
            }
        }
        cout << s.size() << endl;
    }
    return 0;
}